#/function terra_chapter1:cutscene/area_outro/2_clock
#Created by Mithey

scoreboard players add Scene Clock 1

#Give players night vision during this part
effect give @a minecraft:night_vision 20 0 true

#Move camera
execute if score Scene Clock matches 1 run function terra_system:misc/camera_shake_start
execute if score Scene Clock matches 1..200 run execute as @e[tag=SceneCamera] at @s run function terra_system:misc/camera_shake_clock
execute if score Scene Clock matches 200 run function terra_system:misc/camera_shake_end

#Piglin and strider nodding
execute if score Scene Clock matches 41 run execute as @e[tag=Scene_Strider] at @s run function terra_system:animations/talk/start
execute if score Scene Clock matches 61 run execute as @e[tag=Scene_Piglin] at @s run function terra_system:animations/talk/start

#Strider tosses red mushroom to Piglin
execute if score Scene Clock matches 101 run execute as @e[tag=Scene_Strider] at @s run summon minecraft:item ~ ~0.5 ~ {Item:{id:"minecraft:red_mushroom",Count:1b},Motion:[0.1d,0.25d,-0.25d],Tags:["Scene_RedMushroom"]}
execute if score Scene Clock matches 101 run execute as @e[tag=Scene_Strider] at @s run playsound minecraft:entity.item.pickup player @a ~ ~ ~ 1 1.3
execute if score Scene Clock matches 121 run execute as @e[tag=Scene_Strider] at @s run summon minecraft:item ~ ~0.5 ~ {Item:{id:"minecraft:red_mushroom",Count:1b},Motion:[0.1d,0.25d,-0.25d],Tags:["Scene_RedMushroom"]}
execute if score Scene Clock matches 121 run execute as @e[tag=Scene_Strider] at @s run playsound minecraft:entity.item.pickup player @a ~ ~ ~ 1 1.3
execute if score Scene Clock matches 141 run execute as @e[tag=Scene_Strider] at @s run summon minecraft:item ~ ~0.5 ~ {Item:{id:"minecraft:red_mushroom",Count:1b},Motion:[0.1d,0.25d,-0.25d],Tags:["Scene_RedMushroom"]}
execute if score Scene Clock matches 141 run execute as @e[tag=Scene_Strider] at @s run playsound minecraft:entity.item.pickup player @a ~ ~ ~ 1 1.3

#Piglin picks up red mushroom
execute if score Scene Clock matches 171 run execute as @e[tag=Scene_Piglin] at @s run data merge entity @s {HandItems:[{id:"minecraft:red_mushroom",Count:1b}]}
execute if score Scene Clock matches 171 run kill @e[tag=Scene_RedMushroom]
execute if score Scene Clock matches 171 run execute as @e[tag=Scene_Piglin] at @s run playsound minecraft:entity.piglin.admiring_item player @a
execute if score Scene Clock matches 171 run execute as @e[tag=Scene_Piglin] at @s run playsound minecraft:entity.item.pickup player @a
execute if score Scene Clock matches 171 run execute as @e[tag=Scene_Strider] at @s run particle minecraft:happy_villager ~ ~ ~ 1 1 1 0 100 force
execute if score Scene Clock matches 171 run execute as @e[tag=Scene_Piglin] at @s run particle minecraft:happy_villager ~ ~ ~ 1 1 1 0 100 force

#Move camera towards wither skeletons spying
#9926 70 9986 115 25 -> 9936 70 9986 -90 0
execute if score Scene Clock matches 201..270 run execute as @e[tag=SceneCamera] at @s run tp @s ~0.1429 ~0 ~0 ~2.2143 ~-0.3571
execute if score Scene Clock matches 271 run execute as @e[tag=SceneCamera] at @s run tp @s 9946 71 9986 -100 10
execute if score Scene Clock matches 271 run execute as @e[tag=Scene_Strider] at @s run tp @s 9930 69 9976 90 0
execute if score Scene Clock matches 271 run execute as @e[tag=Scene_Piglin] at @s run tp @s 9928 69 9976 -90 0
execute if score Scene Clock matches 271 run function terra_system:misc/camera_shake_start
execute if score Scene Clock matches 271..740 run execute as @e[tag=SceneCamera] at @s run function terra_system:misc/camera_shake_clock
execute if score Scene Clock matches 740 run function terra_system:misc/camera_shake_end
execute if score Scene Clock matches 311 run execute as @e[tag=SceneCamera] at @s run tp @s 9953 72 9986.0 90 20

#"What do we have here? The so-called strider hanging out with our sworn enemy the Piglins?"
execute if score Scene Clock matches 331 run tellraw @a {"translate":"","extra":[{"translate":"\n["},{"translate":"terra.entity.wither_skeleton_twin","color":"red"},{"translate":"] "},{"translate":"terra.chapter1.cutscene.area_outro2"}]}
execute if score Scene Clock matches 331 run execute as @e[tag=Scene_WitherSkeleton1] at @s run function terra_system:animations/talk/start

#"Boss, you know what must be done!"
execute if score Scene Clock matches 471 run tellraw @a {"translate":"","extra":[{"translate":"\n["},{"translate":"terra.entity.wither_skeleton_twin","color":"red"},{"translate":"] "},{"translate":"terra.chapter1.cutscene.area_outro3"}]}
execute if score Scene Clock matches 471 run execute as @e[tag=Scene_WitherSkeleton2] at @s run tp @s ~ ~ ~ facing entity @e[tag=Scene_WitherSkeleton1,limit=1,sort=nearest]
execute if score Scene Clock matches 471 run execute as @e[tag=Scene_WitherSkeleton2] at @s run function terra_system:animations/talk/start

#Particle on strider/piglin again
execute if score Scene Clock matches 571 run execute as @e[tag=Scene_Strider] at @s run particle minecraft:happy_villager ~ ~ ~ 1 1 1 0 100 force
execute if score Scene Clock matches 571 run execute as @e[tag=Scene_Piglin] at @s run particle minecraft:happy_villager ~ ~ ~ 1 1 1 0 100 force

#"Indeed, when the time is right, we will teach the strider a lesson they will never forget!"
execute if score Scene Clock matches 601 run tellraw @a {"translate":"","extra":[{"translate":"\n["},{"translate":"terra.entity.wither_skeleton_twin","color":"red"},{"translate":"] "},{"translate":"terra.chapter1.cutscene.area_outro4"}]}
execute if score Scene Clock matches 601 run execute as @e[tag=Scene_WitherSkeleton1] at @s run tp @s ~ ~ ~ facing entity @e[tag=Scene_WitherSkeleton2,limit=1,sort=nearest]
execute if score Scene Clock matches 601 run execute as @e[tag=Scene_WitherSkeleton1] at @s run function terra_system:animations/talk/start

#Move camera back to strider, piglin goes away off screen, wither skeletons come from other direction and go to attack

#Move camera
execute if score Scene Clock matches 741 run execute as @e[tag=SceneCamera] at @s run tp @s 9932 71 9972 45 20
#9932 71 9972 45 20 -> 9928 71 9972 -15 20
execute if score Scene Clock matches 741..840 run execute as @e[tag=SceneCamera] at @s run tp @s ~-0.04 ~0 ~0 ~-0.6 ~0
execute if score Scene Clock matches 841 run function terra_system:misc/camera_shake_start
execute if score Scene Clock matches 841..1200 run execute as @e[tag=SceneCamera] at @s run function terra_system:misc/camera_shake_clock
execute if score Scene Clock matches 1200 run function terra_system:misc/camera_shake_end

#Move wither skeletons
execute if score Scene Clock matches 741 run execute as @e[tag=Scene_WitherSkeleton1] at @s run tp @s 9941 69 9976 90 0
execute if score Scene Clock matches 741 run execute as @e[tag=Scene_WitherSkeleton2] at @s run tp @s 9941 69 9974 70 0

#Move Piglin off screen
execute if score Scene Clock matches 761..890 run execute as @e[tag=Scene_Piglin] at @s run tp @s ~-0.1 ~ ~ 90 0
execute if score Scene Clock matches 891 run execute as @e[tag=Scene_Piglin] at @s run tp @s ~-500 ~ ~
execute if score Scene Clock matches 891 run execute as @e[tag=Scene_Piglin] at @s run kill @s

#Move wither skeletons
#-9X
execute if score Scene Clock matches 801..890 run execute as @e[tag=Scene_WitherSkeleton1] at @s run tp @s ~-0.1 ~ ~ 90 30
#-4X
execute if score Scene Clock matches 821..860 run execute as @e[tag=Scene_WitherSkeleton2] at @s run tp @s ~-0.1 ~ ~ 75 15

#Wither skeleton equips diamond sword
execute if score Scene Clock matches 851 run execute as @e[tag=Scene_WitherSkeleton1] at @s run data merge entity @s {HandItems:[{id:"minecraft:diamond_sword",Count:1b}]}
execute if score Scene Clock matches 851 run execute as @e[tag=Scene_WitherSkeleton1] at @s run playsound minecraft:item.armor.equip_diamond player @a ~ ~ ~ 5

#Strider notices
execute if score Scene Clock matches 871 run execute as @e[tag=Scene_Strider] at @s run tp @s ~ ~ ~ facing entity @e[tag=Scene_WitherSkeleton1,limit=1,sort=nearest]
execute if score Scene Clock matches 871 run execute as @e[tag=Scene_Strider] at @s run tp @s ~ ~ ~ ~ -30
execute if score Scene Clock matches 871 run execute as @e[tag=Scene_Strider] at @s run playsound minecraft:block.note_block.harp hostile @a ~ ~ ~ 1 2
execute if score Scene Clock matches 871 run execute as @e[tag=Scene_Strider] at @s run summon area_effect_cloud ~ ~2.25 ~ {Duration:20,Passengers:[{id:item,Invulnerable:1,NoGravity:1,Age:5980,PickupDelay:32767,Item:{id:"minecraft:brick",Count:1b,tag:{CustomModelData:22}}}]}

#Move camera
execute if score Scene Clock matches 891 run execute as @e[tag=SceneCamera] at @s run tp @s 9942 70 9960 -45 0

#Stop music
execute if score Scene Clock matches 891 run function terra_system:music/set_song/blank

#Arrows get shot
execute if score Scene Clock matches 901 run playsound minecraft:entity.arrow.shoot player @a 9942 70 9960 10 1.5
execute if score Scene Clock matches 901 run summon minecraft:armor_stand 9957 71 9951 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow1","SceneActor"]}
execute if score Scene Clock matches 931 run playsound minecraft:entity.arrow.shoot player @a 9942 70 9960 10 1.25
execute if score Scene Clock matches 931 run summon minecraft:armor_stand 9957 71 9951 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow2","SceneActor"]}
execute if score Scene Clock matches 941 run playsound minecraft:entity.arrow.shoot player @a 9942 70 9960 10 1.0
execute if score Scene Clock matches 941 run summon minecraft:armor_stand 9957 71 9951 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow3","SceneActor"]}
execute if score Scene Clock matches 901..965 run execute as @e[tag=Scene_Arrow] at @s run tp @s ~-1.6 ~ ~1.6
execute if score Scene Clock matches 901..965 run execute as @e[tag=Scene_Arrow] at @s run particle minecraft:firework ~ ~0.5 ~ 0.1 0.1 0.1 0 1 force
execute if score Scene Clock matches 966 run kill @e[tag=Scene_Arrow]

#Move camera
execute if score Scene Clock matches 971 run execute as @e[tag=SceneCamera] at @s run tp @s 9929 69 9973 -55 10

#Arrow impacts sword
execute if score Scene Clock matches 981 run summon minecraft:armor_stand 9941 69 9966 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow4","SceneActor"]}
execute if score Scene Clock matches 981..990 run execute as @e[tag=Scene_Arrow4] at @s run tp @s ~-1 ~ ~1


#Show wither sword breaking by arrow
execute if score Scene Clock matches 991 run execute as @e[tag=Scene_WitherSkeleton1] at @s run data merge entity @s {HandItems:[{id:"minecraft:brick",Count:1b,tag:{CustomModelData:70}}]}
execute if score Scene Clock matches 991 run execute as @e[tag=Scene_WitherSkeleton1] at @s run particle minecraft:block diamond_block ^ ^ ^0.5 0.1 0.1 0.1 0 25 force
execute if score Scene Clock matches 991 run summon minecraft:armor_stand 9932 69.5 9976 {Invisible:1,Invulnerable:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:71}}],Rotation:[90f,0f],Tags:["Scene_SwordBlade","SceneActor"],Motion:[-1d,2d,1d]}
execute if score Scene Clock matches 991 run playsound minecraft:block.anvil.land player @a 9932 69 9976 10 2
execute if score Scene Clock matches 993 run kill @e[tag=Scene_Arrow4]

#Wither skeleton looks back
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton1] at @s run tp @s ~ ~ ~ ~-135 ~
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton1] at @s run playsound minecraft:block.note_block.harp hostile @a ~ ~ ~ 1 2
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton1] at @s run summon area_effect_cloud ~ ~2.25 ~ {Duration:20,Passengers:[{id:item,Invulnerable:1,NoGravity:1,Age:5980,PickupDelay:32767,Item:{id:"minecraft:brick",Count:1b,tag:{CustomModelData:22}}}]}

#Arrows impact skeletons
execute if score Scene Clock matches 1001 run execute as @e[tag=Scene_WitherSkeleton2] at @s run summon minecraft:armor_stand ~10 ~ ~-10 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow5","SceneActor"]}
execute if score Scene Clock matches 1001..1010 run execute as @e[tag=Scene_Arrow5] at @s run tp @s ~-1 ~ ~1
execute if score Scene Clock matches 1013 run kill @e[tag=Scene_Arrow5]
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton1] at @s run summon minecraft:armor_stand ~10 ~ ~-10 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow6","SceneActor"]}
execute if score Scene Clock matches 1011..1020 run execute as @e[tag=Scene_Arrow6] at @s run tp @s ~-1 ~ ~1
execute if score Scene Clock matches 1023 run kill @e[tag=Scene_Arrow6]

#Wither skeleton 2 goes flying
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton2] at @s run data merge entity @s {NoAI:0,Motion:[-3d,0.75d,1.5d]}
execute if score Scene Clock matches 1011 run execute as @e[tag=Scene_WitherSkeleton2] at @s run effect give @s minecraft:instant_health 1 0

#Wither skeleton 1 goes flying
execute if score Scene Clock matches 1021 run execute as @e[tag=Scene_WitherSkeleton1] at @s run data merge entity @s {NoAI:0,Motion:[-3d,0.75d,1.5d]}
execute if score Scene Clock matches 1021 run execute as @e[tag=Scene_WitherSkeleton1] at @s run effect give @s minecraft:instant_health 1 0

#Give back NoAI and move skeletons in place next to tree
execute if score Scene Clock matches 1031 run execute as @e[tag=Scene_WitherSkeleton] at @s run data merge entity @s {NoAI:1}
execute if score Scene Clock matches 1031 run execute as @e[tag=Scene_SwordBlade] at @s run tp @s 9922 69 9988 0 0
execute if score Scene Clock matches 1031 run execute as @e[tag=Scene_WitherSkeleton1] at @s run tp @s 9918 73 9982 -130 35
execute if score Scene Clock matches 1031 run execute as @e[tag=Scene_WitherSkeleton2] at @s run tp @s 9914 70 9978 -90 0
execute if score Scene Clock matches 1031 run summon minecraft:armor_stand 9918 73 9982 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[45f,0f],Tags:["Scene_Arrow","Scene_Arrow3","SceneActor"]}
execute if score Scene Clock matches 1031 run summon minecraft:armor_stand 9914 70.5 9978 {Invisible:1,Invulnerable:1,Marker:1,NoGravity:1,ArmorItems:[{},{},{},{id:"minecraft:brick",Count:1b,tag:{CustomModelData:69}}],Rotation:[90f,0f],Tags:["Scene_Arrow","Scene_Arrow3","SceneActor"]}

#Move camera
execute if score Scene Clock matches 1041 run execute as @e[tag=SceneCamera] at @s run tp @s 9920 70 9976 45 -10

#"A villager?! Here?!"
execute if score Scene Clock matches 1061 run tellraw @a {"translate":"","extra":[{"translate":"\n["},{"translate":"terra.entity.wither_skeleton_twin","color":"red"},{"translate":"] "},{"translate":"terra.chapter1.cutscene.area_outro5"}]}
execute if score Scene Clock matches 1061 run execute as @e[tag=Scene_WitherSkeleton1] at @s run function terra_system:animations/talk/start

#Make villager noise
execute if score Scene Clock matches 1141 run execute as @a at @s run playsound minecraft:entity.villager.celebrate player @s ~ ~ ~ 10 1.5
execute if score Scene Clock matches 1151 run execute as @a at @s run playsound minecraft:entity.villager.celebrate player @s ~ ~ ~ 10 1.5
execute if score Scene Clock matches 1161 run execute as @a at @s run playsound minecraft:entity.villager.celebrate player @s ~ ~ ~ 10 1.5




#Move cameras 2-3 to the left/right of camera 1
execute as @e[tag=SceneCamera2] at @e[tag=SceneCamera1] run tp @s ^1.0 ^ ^ ~ ~
execute as @e[tag=SceneCamera3] at @e[tag=SceneCamera1] run tp @s ^-1.0 ^ ^ ~ ~

#Teleport players to their cameras
scoreboard players add SceneSkipTeleport Clock 1
execute unless score SceneSkipTeleport Clock matches 20.. run execute as @e[tag=SceneCamera1] at @s run tp @a[scores={PlayerID=1}] ~ ~ ~ ~ ~
execute unless score SceneSkipTeleport Clock matches 20.. run execute as @e[tag=SceneCamera2] at @s run tp @a[scores={PlayerID=2}] ~ ~ ~ ~ ~
execute unless score SceneSkipTeleport Clock matches 20.. run execute as @e[tag=SceneCamera3] at @s run tp @a[scores={PlayerID=3..}] ~ ~ ~ ~ ~
execute if score SceneSkipTeleport Clock matches 20.. run scoreboard players set SceneSkipTeleport Clock 0

#End current scene
execute if score Scene Clock matches 1200.. run data merge block ~ ~ ~ {Command:"function terra_chapter1:cutscene/area_outro/2_end_attempt"}














