#/function terra_system:items/on_inventory_change_tick
#Created by Mithey

#NOTE: This is being run one tick later to avoid an invisible item Minecraft bug

#Give only the weapons the player is meant to have
function terra_system:items/weapons/clear_weapons
function terra_system:items/weapons/give_weapons

#Give only the pickaxe the player is meant to have
execute if block 111 4 -31 green_wool run function terra_system:items/pickaxes/clear_pickaxes
execute if block 111 4 -31 green_wool run function terra_system:items/pickaxes/give_pickaxes

#Give player back main menu if they are missing it
execute store result score Inventory Temp run clear @s minecraft:carrot_on_a_stick{ItemTags:["MainMenu"]} 0
execute if score Inventory Temp matches 0 run scoreboard players set Amount Temp 1
execute if score Inventory Temp matches 0 run function terra_system:items/misc/main_menu/give

#Give player back potion of rejuvenation if they are missing it
execute if block 110 4 -31 green_wool run execute store result score Inventory Temp run clear @s minecraft:potion{PotionOfRejuvenation:1} 0
execute if block 110 4 -31 green_wool run execute store result score Inventory2 Temp run clear @s minecraft:glass_bottle{PotionOfRejuvenation:1} 0
execute if block 110 4 -31 green_wool run execute if score Inventory Temp matches 0 run execute if score Inventory2 Temp matches 0 run function terra_system:items/misc/potion_of_rejuvenation/give

#Give player back turn left/right if they are missing it
execute if block 107 4 -31 minecraft:green_wool run execute store result score Inventory Temp run clear @s minecraft:carrot_on_a_stick{ItemTags:["Item_TurnLeft"]} 0
execute if block 107 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run scoreboard players set Amount Temp 1
execute if block 107 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run function terra_system:items/misc/turn_left/give
execute if block 107 4 -31 minecraft:green_wool run execute store result score Inventory Temp run clear @s minecraft:carrot_on_a_stick{ItemTags:["Item_TurnRight"]} 0
execute if block 107 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run scoreboard players set Amount Temp 1
execute if block 107 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run function terra_system:items/misc/turn_right/give

#Give player back stop/resume if they are missing it
execute if block 106 4 -31 minecraft:green_wool run execute store result score Inventory Temp run clear @s minecraft:carrot_on_a_stick{ItemTags:["Item_StopResume"]} 0
execute if block 106 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run scoreboard players set Amount Temp 1
execute if block 106 4 -31 minecraft:green_wool run execute if score Inventory Temp matches 0 run function terra_system:items/misc/stop_resume/give

#Clean up
tag @s remove InventoryChanged
scoreboard players reset Inventory Temp
scoreboard players reset Inventory2 Temp







