#/function terra_system:items/head/tier_1/copper/craft_attempt
#Created by Mithey

#Parameters:
#CraftingAmount Temp = Number of crafting attempts

#Ensure amount of crafting attempts is always at least 1
execute unless score CraftingAmount Temp matches 1.. run scoreboard players set CraftingAmount Temp 1

#Set amount of items required
scoreboard players set CraftingRequirement1 Temp 5
execute if score CraftingAmount Temp matches 10 run scoreboard players operation CraftingRequirement1 Temp *= 10 Number
execute if score CraftingAmount Temp matches 64 run scoreboard players operation CraftingRequirement1 Temp *= 64 Number
#scoreboard players set CraftingRequirement2 Temp 1
#execute if score CraftingAmount Temp matches 10 run scoreboard players operation CraftingRequirement2 Temp *= 10 Number
#execute if score CraftingAmount Temp matches 64 run scoreboard players operation CraftingRequirement2 Temp *= 64 Number
#scoreboard players set CraftingRequirement3 Temp 1
#execute if score CraftingAmount Temp matches 10 run scoreboard players operation CraftingRequirement3 Temp *= 10 Number
#execute if score CraftingAmount Temp matches 64 run scoreboard players operation CraftingRequirement3 Temp *= 64 Number

#Check if player has required items
scoreboard players set Outcome Temp 1
execute store result score Amount1 Temp run clear @s minecraft:brick{ItemTags:["Item_MaterialsIngotCopper"]} 0
#execute store result score Amount2 Temp run clear @s minecraft:brick{ItemTags:["Item_MaterialsIngotCopper"]} 0
#execute store result score Amount3 Temp run clear @s minecraft:brick{ItemTags:["Item_MaterialsIngotCopper"]} 0
execute unless score Amount1 Temp >= CraftingRequirement1 Temp run scoreboard players set Outcome Temp 0
#execute unless score Amount2 Temp >= CraftingRequirement2 Temp run scoreboard players set Outcome Temp 0
#execute unless score Amount3 Temp >= CraftingRequirement3 Temp run scoreboard players set Outcome Temp 0

#Check if already crafted before
execute if block 108 7 -32 minecraft:green_wool run scoreboard players set Outcome Temp -1

#If player doesn't have required items
execute if score Outcome Temp matches 0 run tellraw @s {"translate":"terra.crafting.no_materials","bold":true,"color":"red"}
execute if score Outcome Temp matches 0 run playsound minecraft:sfx_negative player @s ~ ~ ~

#If player already crafted the item before
execute if score Outcome Temp matches -1 run tellraw @s {"translate":"terra.crafting.already_crafted","bold":true,"color":"red"}
execute if score Outcome Temp matches -1 run playsound minecraft:sfx_negative player @s ~ ~ ~

#If player has required items
execute if score Outcome Temp matches 1 run function terra_system:items/head/tier_1/copper/craft

#Clean up
scoreboard players reset Amount1 Temp
scoreboard players reset Amount2 Temp
scoreboard players reset Amount3 Temp
scoreboard players reset CraftingRequirement1 Temp
scoreboard players reset CraftingRequirement2 Temp
scoreboard players reset CraftingRequirement3 Temp
scoreboard players reset Outcome Temp
scoreboard players reset CraftingAmount Temp









