#/function terra_system:on_join
#Created by Mithey

#Do first time set up if first time anyone joined
execute if block 111 4 -32 minecraft:red_wool run function terra_system:on_first_time_world_load

#First time joining stuff
execute as @s[tag=!JoinedBefore] at @s run function terra_system:on_first_time_join

#Assign unique player ID for player
function terra_system:misc/assign_unique_player_id

#Join the correct team
execute if score @s PlayerID matches 1 run team join P1 @s
execute if score @s PlayerID matches 2 run team join P2 @s
execute if score @s PlayerID matches 3 run team join P3 @s
execute if score @s PlayerID matches 4 run team join P4 @s
execute if score @s PlayerID matches 5 run team join P5 @s
execute if score @s PlayerID matches 6 run team join P6 @s
execute if score @s PlayerID matches 7 run team join P7 @s
execute if score @s PlayerID matches 8 run team join P8 @s
execute if score @s PlayerID matches 9 run team join P9 @s
execute if score @s PlayerID matches 10 run team join P10 @s
execute if score @s PlayerID matches 11 run team join P11 @s

#Re-equip armor
execute unless score TerraRestore InCutscene matches 1 run function terra_system:items/head/reequip_head_no_message

#Setup health bar for player
function terra_system:health/health_bar/reset_players
function terra_system:health/health_bar/update
function terra_system:health/health_bar/show

#Setup spirit bar for player
function terra_system:spirit/spirit_bar/reset_players
function terra_system:spirit/spirit_bar/update
function terra_system:spirit/spirit_bar/show

#Setup stamina bar for player
function terra_system:stamina/stamina_bar/reset_players
function terra_system:stamina/stamina_bar/update
function terra_system:stamina/stamina_bar/show

#Setup exp bar for player
function terra_system:exp/exp_bar/reset_players
function terra_system:exp/exp_bar/update
function terra_system:exp/exp_bar/hide

#Set gamemode
gamemode adventure @s
execute if score TerraRestore InCutscene matches 1 run gamemode spectator @s

#Start music up again for player
scoreboard players set @s Music 9999

#If music enabled, display song name
execute if block 110 4 -32 minecraft:green_wool run function terra_system:music/display_music_name

#Remove area bound items if player is now in different area
execute unless entity @s[scores={IsSameArea=1}] run function terra_system:misc/clear_area_bound_items
scoreboard players set @s IsSameArea 1

#Teleport and set spawnpoint to current spawnpoint if newer spawnpoint set
execute unless entity @s[scores={IsSameSpawn=1}] run function terra_system:misc/move_player_to_current_spawn
scoreboard players set @s IsSameSpawn 1

#Calculate new attributes
scoreboard players set DontDisplayMessage Temp 1
function terra_system:stats/calculate_stats_no_message

#Sound effect for logging in
execute as @a at @s run playsound minecraft:entity.player.levelup player @s ~ ~ ~ 2 0.5

#Ensure player has all current items
function terra_system:items/on_inventory_change_tick

#Recalculate max natural mob spawns
function terra_system:entities/calculate_max_natural_mob_spawns

#Make it so player can see boss bars whenever they get displayed
bossbar set minecraft:200 players @a
bossbar set minecraft:201 players @a
bossbar set minecraft:202 players @a

#Display login message on delay
scoreboard players set @s LoginMessage -20









