#/function terra_system:stats/calculate_health
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Displays total Health and how much you gained or lost

#RETURNS:
#@s Health - How much Health you have

#Store old health
scoreboard players operation OldHealthTotal Temp = @s StatHpMax

#Reset Health
scoreboard players set @s StatHpMax 10000

#Armor Health
scoreboard players operation @s StatHpMax += @s HealthFeet
scoreboard players operation @s StatHpMax += @s HealthLegs
scoreboard players operation @s StatHpMax += @s HealthChest
scoreboard players operation @s StatHpMax += @s HealthHead

#Weapon Health
scoreboard players operation @s StatHpMax += @s HealthWeapon1
scoreboard players operation @s StatHpMax += @s HealthWeapon2

#Ensure health is always above 0
execute if score @s StatHpMax matches ..0 run scoreboard players set @s StatHpMax 1

#Display total Health
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation TotalHealth Temp = @s StatHpMax
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation TotalHealth Temp /= 100 Number
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation HealthGain Temp = @s StatHpMax
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation HealthGain Temp -= OldHealthTotal Temp
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation HealthGain Temp /= 100 Number
execute unless score DontDisplayMessage Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"\n"},{"translate":"terra.stats.health"},{"translate":": "},{"score":{"name":"TotalHealth","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":" ("},{"translate":"terra.stats.you_gained","color":"gray"},{"translate":" "},{"score":{"name":"HealthGain","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":")","color":"gray"}]}

function terra_system:health/health_bar/update

#Clean up
scoreboard players reset HealthGain Temp
scoreboard players reset OldHealthTotal Temp
scoreboard players reset TotalHealth Temp
scoreboard players reset DontDisplayMessage Temp
scoreboard players reset DontMakeSound Temp








